/*
 * 	Easy Paginate 1.0 - jQuery plugin
 *	written by Alen Grakalic	
 *	http://cssglobe.com/
 *
 *  modified by Olivier Buisard
 *
 *	Copyright (c) 2011 Alen Grakalic (http://cssglobe.com)
 *	Dual licensed under the MIT (MIT-LICENSE.txt)
 *	and GPL (GPL-LICENSE.txt) licenses.
 *
 *	Built for jQuery library
 *	http://jquery.com
 *
 */

(function($) {
		  
	$.fn.easyPaginate = function(options){

		var defaults = {				
			step: 4,
			delay: 100,
			numeric: true,
			nextprev: true,
			auto: false,
			loop: false,
			pause: 4000,
			clickstop: true,
			controls: 'pagination',
			current: 'current',
			randomstart: false,
			prevlabel: 'prev',
			nextlabel: 'next'
		}; 
		
		var options = $.extend(defaults, options); 
		var step = options.step;
		var lower, upper;
		var children = $(this).children();
		var count = children.length;
		var obj, next, prev;		
		var pages = Math.floor(count/step);
		var page = (options.randomstart) ? Math.floor(Math.random()*pages)+1 : 1;
		var timeout;
		var clicked = false;
		
		function show(){
			clearTimeout(timeout);
			lower = ((page-1) * step);
			upper = lower+step;
			$(children).each(function(i){
				var child = $(this);
				
				// set display to inline so when hidden and shown again, it returns to inline and not block
				child.css('display', 'inline');
				
				child.hide();
				if(i>=lower && i<upper){ setTimeout(function(){ child.fadeIn('fast') }, ( i-( Math.floor(i/step) * step) )*options.delay ); }
				if(options.nextprev){
					//if(upper >= count) { next.hide(); } else { next.show(); };
					//if(lower >= 1) { prev.show(); } else { prev.hide(); };
					if(upper >= count) { next.addClass('disabled'); } else { next.removeClass('disabled'); };
					if(lower >= 1) { prev.removeClass('disabled'); } else { prev.addClass('disabled'); };
				};
			});	
			$('li','.'+ options.controls).removeClass(options.current);
			$('li[data-index="'+page+'"]','.'+ options.controls).addClass(options.current);
			
			if(options.auto){
				if(options.clickstop && clicked){}else{ timeout = setTimeout(auto,options.pause); };
			};
		};
		
		function auto(){
			if(options.loop) if(upper >= count){ page=0; show(); }
			if(upper < count){ page++; show(); }				
		};
		
		this.each(function(){ 
			
			obj = this;
			
			if(count>step){
								
				if((count/step) > pages) pages++;
				
				var div = $('<div class="'+ options.controls +'"></div>').insertAfter(obj);
				var ol = $('<ul></ul>').appendTo(div);
				
				if(options.nextprev){
					prev = $('<li class="previous"><span>'+ options.prevlabel +'</span></li>')
						//.hide()
						.appendTo(ol)
						.click(function(){
							if(lower >= 1) {
								clicked = true;
								page--;
								show();
							}
						});
				};
				
				if(options.numeric){
					for(var i=1;i<=pages;i++){
					$('<li data-index="'+ i +'"><span>'+ i +'</span></li>')
						.appendTo(ol)
						.click(function(){	
							if (!$(this).hasClass('active')) {
								clicked = true;
								page = $(this).attr('data-index');
								show();	
							}										
						});					
					};				
				};
				
				if(options.nextprev){
					next = $('<li class="next"><span>'+ options.nextlabel +'</span></li>')
						//.hide()
						.appendTo(ol)
						.click(function(){
							if(upper < count) {
								clicked = true;
								page++;
								show();
							}							
						});
				};
			
				show();
			};
		});	
		
	};	

})(jQuery);